--- old/kb1ec_const.h   2007-05-10 21:09:26.471938770 +0930
+++ new/kb1ec_const.h   2007-05-10 21:09:19.909995453 +0930
@@ -51,18 +51,24 @@
 /* This knob controls the number of passes the residual echo supression
  * algorithm makes.
  */
 #ifdef AGGRESSIVE_SUPPRESSOR
  #define RESIDUAL_SUPRESSION_PASSES 2
 #else
  #define RESIDUAL_SUPRESSION_PASSES 1
 #endif

+/* If defined then agressive echo cancellation will only be used for
+ * this amount of time then we will go back to normal cancelation.
+ * This is helpful if you have bad echo while training
+ */
+/* #define AGGRESSIVE_TIMELIMIT 150000 */ /* 8 = 1ms */
+

 /***************************************************************/
 /* The following knobs are not implemented in the current code */

 /* we need a dynamic level of suppression varying with the ratio of the
    power of the echo to the power of the reference signal this is
    done so that we have a  smoother background.
    we have a higher suppression when the power ratio is closer to
    suppr_ceil and reduces logarithmically as we approach suppr_floor.
diff -u9 old/kb1ec.h new/kb1ec.h
--- old/kb1ec.h 2007-05-10 21:09:26.471938770 +0930
+++ new/kb1ec.h 2007-05-10 21:09:19.909995453 +0930
@@ -429,48 +429,59 @@
         * then perform residual error suppression
         */
 #ifdef MEC2_STATS_DETAILED
        if (ec->HCNTR_d == 0)
                printk( KERN_INFO "possibily correcting frame with ec->Ly_i %9d ec->Lu_i %9d and expression %d\n", ec->Ly_i, ec->Lu_i, (ec->Ly_i/(ec->Lu_i + 1)));
 #endif

 #ifndef NO_ECHO_SUPPRESSOR
 #ifdef AGGRESSIVE_SUPPRESSOR
+#ifdef AGGRESSIVE_TIMELIMIT
+       if (ec->i_d < AGGRESSIVE_TIMELIMIT ) {
+#endif
        if ((ec->HCNTR_d < AGGRESSIVE_HCNTR) && (ec->Ly_i > (ec->Lu_i << 1))) {
                for (k=0; k < RESIDUAL_SUPRESSION_PASSES; k++) {
                        u = u * (ec->Lu_i >> DEFAULT_SIGMA_LU_I) / ((ec->Ly_i >> (DEFAULT_SIGMA_LY_I)) + 1);
                }
 #ifdef MEC2_STATS_DETAILED
                printk( KERN_INFO "aggresively correcting frame with ec->Ly_i %9d ec->Lu_i %9d expression %d\n", ec->Ly_i, ec->Lu_i, (ec->Ly_i/(ec->Lu_i + 1)));
 #endif
 #ifdef MEC2_STATS
                ++ec->cntr_residualcorrected_frames;
 #endif
        }
-#else
+#ifdef AGGRESSIVE_TIMELIMIT
+       }
+       else {
+#endif
+#endif
+#if (defined AGGRESSIVE_SUPPRESSOR  && defined AGGRESSIVE_TIMELIMIT) || !defined AGGRESSIVE_SUPPRESSOR
        if (ec->HCNTR_d == 0) {
                if ((ec->Ly_i/(ec->Lu_i + 1)) > DEFAULT_SUPPR_I) {
                        for (k=0; k < RESIDUAL_SUPRESSION_PASSES; k++) {
                                u = u * (ec->Lu_i >> DEFAULT_SIGMA_LU_I) / ((ec->Ly_i >> (DEFAULT_SIGMA_LY_I + 2)) + 1);
                        }
 #ifdef MEC2_STATS_DETAILED
                        printk( KERN_INFO "correcting frame with ec->Ly_i %9d ec->Lu_i %9d expression %d\n", ec->Ly_i, ec->Lu_i, (ec->Ly_i/(ec->Lu_i + 1)));
 #endif
 #ifdef MEC2_STATS
                        ++ec->cntr_residualcorrected_frames;
 #endif
                }
 #ifdef MEC2_STATS
                else {
                                ++ec->cntr_residualcorrected_framesskipped;
                }
 #endif
        }
+#ifdef AGGRESSIVE_TIMELIMIT
+       }
+#endif
 #endif
 #endif

 #if 0
        /* This will generate a non-linear supression factor, once converted */
        if ((ec->HCNTR_d == 0) &&
           ((ec->Lu_d/ec->Ly_d) < DEFAULT_SUPPR) &&
            (ec->Lu_d/ec->Ly_d > EC_MIN_DB_VALUE)) {
                suppr_factor = (10 / (float)(SUPPR_FLOOR - SUPPR_CEIL)) * log(ec->Lu_d/ec->Ly_d)
